#! /bin/sh
###################################################################
# Business Printer Control interface program
#   COPYRIGHT FUJITSU LIMITED 2003-2018
###################################################################
# IN:BSNPS_OPT_DIR
# IN:TMP_PATH
# IN:BSNPS_VAR_PATH
# IN:BSNPS_ETC_PATH
PRWEB_VAR_PATH="/var/opt/FJSVprweb/prweb/var_tmp/FJSVprweb/"
#COMENT ƽФˤѹ   2002.09.05
if [ -n "${BSPRTCTLDATE}" ]; then
	BSPRT20_PRT_NAME="$1"
	BSPRT20_REQ___ID="$2"
	BSPRT20_USR_NAME="$3"
	BSPRT20_TTL__STR="$4"
	BSPRT20_COPY_VAL="$5"
	BSPRT20_O_OPTION="$6"
	BSPRT20_FILE_VAL="$7"
	BSPRT20_FILE_STR="$8"
else
	BSPRT20_PRT_NAME=`basename $0`
	BSPRT20_REQ___ID="$1"
	BSPRT20_USR_NAME="$2"
	BSPRT20_TTL__STR="$3"
	BSPRT20_COPY_VAL="$4"
	BSPRT20_O_OPTION="$5"
	shift 5
	BSPRT20_FILE_VAL=$#
	BSPRT20_FILE_STR="$*"
fi
#COMENT ƽФˤѹ   2002.09.05

trap '' 13
FMLPCAT=0
EXLOOP=0
FMFIL=0
LPCAT=""
PREINIT=""
#COMENT ե륿۾ｪλ(127)ξνλͤ136129ѹ ###
EXEC_EXIT_NALRT=129
exit_code=${EXEC_EXIT_NALRT}
LP_IF_DTYPE=""
LP_IF_COPIES=""
LP_IF_FILES=""
LPJEF=""
PSBANNER=""
export FMLPCAT LPCAT PREINIT EXEC_EXIT_NALRT LP_IF_DTYPE LP_IF_COPIES LP_IF_FILES LPJEF PSBANNER

#COMENT BSNPSENVѿ 2001.4.20 ##
BSNPS_USRTELALT="";	export BSNPS_USRTELALT  #桼顼ȥޥϿ
BSNPS_USRTELEND=""
BSNPS_NOBANNER=""
BSNPS_EXT_FILTER=""
#COMENT BSNPSENVѿ 2001.4.20 ##

lpstat_cmd=${BSNPS_OPT_DIR}/bsnpslpstat # lpstatޥ  1999.12.15 add

#COMENT pageեκ    #####
request_id=${BSPRT20_REQ___ID};		export request_id

trap 'exit' 15

catch_hangup () {
	if [ -n "${LPTELL}" ]
	then
		echo \
"The connection to the printer dropped; perhaps the printer went off-line?" \
		| ${LPTELL} ${printer}
	fi
	return 0
}
catch_interrupt () {
	if [ -n "${LPTELL}" ]
	then
		echo \
"Received an interrupt from the printer.  The reason is unknown,
although a common cause is that the baud rate is too high." \
		| ${LPTELL} ${printer}
	fi
	return 0
}
trap 'catch_hangup; exit_code=129 exit 129' 1
trap 'catch_interrupt; exit_code=129 exit 129' 2 3

exec 5>&2 2>/dev/null 3>&1
#exec 5>&2 2>${TMP_PATH}/standard.log 3>&1

trap 'exit_code=0 exit' 19

: ${TERM:=unknown}
: ${TMPDIR:=/tmp}
: ${SPOOLDIR:=/usr/spool/lp}
: ${TERMINFO:=/usr/lib/terminfo}
: ${CHARSETDIR:=/usr/lib/charsets}

: ${LOCALPATH:=${SPOOLDIR}/bin}
PATH="/bin:/usr/bin:${LOCALPATH}"

MAX_COLS_SMALL_BANNER=40

TMPPREFIX=${TMP_PATH}/`uname -n`$$.FJSVbsnps.
PREINIT=${TMP_PATH}/${TERM}.pi

PRCNV_OPT_PATH="/opt/FJSVprcnv"	#Linuxѥ
printer=${BSPRT20_PRT_NAME}
CANCEL_FILE_1=/var/opt/FJSVbsnps/bsnps/var_tmp/FJSVbsnps/cancel/${request_id}.1
CANCEL_FILE_2=/var/opt/FJSVbsnps/bsnps/var_tmp/FJSVbsnps/cancel/${request_id}.2
bsnpsendexec () {
	rm -fr /var/opt/FJSVbsnps/bsnps/tmp/`uname -n`$$.FJSVbsnps.*       #<<R_023>> mod(TMPPREFIX->fullpath)
        rm -fr ${CANCEL_FILE_1}
        rm -fr ${CANCEL_FILE_2}
	if [ ${exit_code} -eq 0 -a "${LP_IF_DTYPE}" != "4" ]; then
		if [ -n "${BSNPS_USRTELEND}" ]; then
			BSNPS_USRTELEND_ERR=""
			eval ${BSNPS_USRTELEND}
			if [ -n "${BSNPS_USRTELEND_ERR}" ]; then
				echo "${BSNPS_USRTELEND_ERR}" | ${LPTELL} ${printer}
				exit_code=$EXEC_EXIT_NALRT
			fi
		fi
	fi
}
trap 'bsnpsendexec; exit ${exit_code}' 0
trap 'bsnpsendexec; exit' 15

if [ ! -x "${LPTELL:=${BSNPS_OPT_DIR}/lp.tell2S}" ]
then
	fake_lptell () {
		header="no"
		while read line
		do
			if [ "no" = "${header}" ]
			then
				errmsg ERROR ${E_IP_UNKNOWN} \
		"unknown printer/interface failure" \
		"consult your system administrator;
		reasons for failure (if any) follow:"
				header=yes
			fi
			echo "${line}" >&2
		done
		return 1
	}
	LPTELL=fake_lptell
fi
#COMENT# TERMѿ 2002.2.8 ##
PRTTYPEINFO="${BSNPS_ETC_PATH}/bsnps/prttypeinfo"
BSNPS_TERM=""
BSNPS_ERR_TERM=""
		BSNPS_TERM_LINE=`grep "^${TERM} " ${PRTTYPEINFO}`
		BSNPS_TERM=`echo "${BSNPS_TERM_LINE}"     | ${BSNPS_OPT_DIR}/bsnps_awk -m0 -p2`	#awk '{print $2}'`
		BSNPS_ERR_TERM=`echo "${BSNPS_TERM_LINE}" | ${BSNPS_OPT_DIR}/bsnps_awk -m0 -p3`	#awk '{print $3}'`
#BSNPS_ENT_TERM=${BSNPS_ERR_TERM};	export BSNPS_ENT_TERM	#ɽ̾ banneroptsǻ 2002.04.08
BSNPS_ENT_TERM=${BSNPS_TERM}; export BSNPS_ENT_TERM	#ɽ̾ banneroptsǻ 2004.10.26 prttypeinfo軰󤫤ѹ
export BSNPS_TERM BSNPS_ERR_TERM
#COMENT# TERMѿ 2002.2.8 ##

#COMENT# BPC 3.0 add start ##
	NOBANNER=`echo ${BSPRT20_O_OPTION} | grep "nobanner"`
	if [ -n "${NOBANNER}" ]
	then
		FILTER="${FILTER} -x"
	fi
#COMENT# BPC 3.0 add end ##
	ORIGINAL_FILTER="${FILTER}"     #BSPRTCTL2.0
	FILTER="${FILTER} ${BSPRT20_REQ___ID}"

#COMENT# BSNPSENVѿ 2001.4.20 ##
#SCP7200		bsnpsenvsetptn=`${BSNPS_OPT_DIR}/readbsnpsenv USRTELALT USRTELEND NOBANNER`
#SCP7200		BSNPS_USRTELALT=`echo "$bsnpsenvsetptn" | awk -F"	" '{print $1}' | sed 's/^n$//g'`
#SCP7200		BSNPS_USRTELEND=`echo "$bsnpsenvsetptn" | awk -F"	" '{print $2}' | sed 's/^n$//g'`
#SCP7200		BSNPS_NOBANNER=`echo "$bsnpsenvsetptn"  | awk -F"	" '{print $3}' | sed 's/^n$//g'`
#COMENT# BSNPSENVѿ 2001.4.20 ##

FMLPCAT=0
BSNPS_FILTER_TYPE=0					#1998.11.09 add
filarg=`expr "|${FILTER}" : ".*| *\(.*\)"`
while [ -n "${filarg}" ]
do
	case "${filarg} " in
	"${BSNPS_OPT_DIR}/bsnpscatvspf66xx "* )
		if [ -x "${BSNPS_OPT_DIR}/bsnpscatvspf66xx" ]
		then
			LPCAT="${filarg}"
		        LPJEF="${BSNPS_OPT_DIR}/bsnpscatvspf66xx"
			FMFIL=1
			EXLOOP=1
			FMLPCAT=1
			BSNPS_FILTER_TYPE=1                 #1998.11.09 add
			BSNPS_BANNER_TYPE=1                 #2001.11.13 add
			break
		fi;;
	"${BSNPS_OPT_DIR}/bsnpscatvspfmfnp "* )
		if [ -x "${BSNPS_OPT_DIR}/bsnpscatvspfmfnp" ]
		then
			LPCAT="${filarg}"
			EXLOOP=1
			FMLPCAT=3
			BSNPS_FILTER_TYPE=3
			BSNPS_BANNER_TYPE=3                 #2001.11.13 add
			break
		fi;;
	"${BSNPS_OPT_DIR}/bsnpscatvspps "* )
		if [ -x "${BSNPS_OPT_DIR}/bsnpscatvspps" ]
		then
			LPCAT="${filarg}"
			EXLOOP=1
			FMLPCAT=3
		        PSBANNER="${BSNPS_OPT_DIR}/bsnpscatvspps"
			FMFIL=1
			BSNPS_FILTER_TYPE=4                 #1998.11.09 add
			BSNPS_BANNER_TYPE=4                 #2001.11.13 add
			break
		fi;;
	esac
	filarg=`expr "|${FILTER}" : ".*| *\(.*\) *| *${filarg}"`
done
BSNPS_CANWATCH_TYPE=$BSNPS_FILTER_TYPE                  #2002.09.12
TPUT=tput

LP_ERR_LABEL="UX:lp"

E_IP_ARGS=1
E_IP_OPTS=2
E_IP_STTY=4
E_IP_UNKNOWN=5
E_IP_BADFILE=6
E_IP_BADCHARSET=7
E_IP_BADCPI=8
E_IP_BADLPI=9
E_IP_BADWIDTH=10
E_IP_BADLENGTH=11
E_IP_ERRORS=12		# (in slow.filter)

errmsg () {
	case $1 in
	ERROR )
		sev="  ERROR";
		;;
	WARNING )
		sev="WARNING";
		;;
	esac
	echo "${LP_ERR_LABEL}: ${sev}: $3
	TO FIX: $4" >&5
}

parse () {
	echo "`expr \"$1\" : \"^[^=]*=\(.*\)\"`"
}

if [ $# -lt 5 ]
then
	errmsg ERROR ${E_IP_ARGS} \
		"wrong number of arguments to interface program" \
		"consult your system administrator"
	exit 1
fi
printer=${BSPRT20_PRT_NAME}
user_name=${BSPRT20_USR_NAME};	export user_name
title=${BSPRT20_TTL__STR}
TITLE=${BSPRT20_TTL__STR}
copies=${BSPRT20_COPY_VAL}
option_list=${BSPRT20_O_OPTION}
export TITLE
#COMENT# TITLEԽ(2ܰʹߤ) 2001.4.20 ##
BSNPS_TITLE=`echo "${title}" |sed -e '2,$d'`
export BSNPS_TITLE
#COMENT# TITLEԽ(2ܰʹߤ) 2001.4.20 ##

#COMENT###### 2002.04.04 add for ȥĥ ########
npsu_user_name=""
#SCP7200	if [ "${BSNPS_FOR_NPS}" = "NPSU" ]; then
#SCP7200		geu_L=`expr "${BSNPS_TITLE}" : ".*%~\(.*~%.*\)"`	#%~ʹ
#SCP7200		if [ -n "$geu_L" ]; then
#SCP7200			geu_L=`expr "${geu_L}" : "\(.*\)~%.*"`	#~%
#SCP7200			geu_F=""
#SCP7200			for geu_I in ${geu_L}
#SCP7200			do
#SCP7200				geu_K=`expr "${geu_I}" : "\(.\):.*"`
#SCP7200				case "${geu_K}" in
#SCP7200				"" )	#ѥ᥿˶򤬤ν
#SCP7200					case "${geu_F}" in
#SCP7200					"U" )
#SCP7200						npsu_user_name="${npsu_user_name} ${geu_I}" ;;
#SCP7200					esac ;;
#SCP7200				"U" )
#SCP7200					npsu_user_name=`expr "${geu_I}" : "U:\(.*\)"`
#SCP7200					geu_F="U" ;;
#SCP7200				* )
#SCP7200					geu_F="" ;;
#SCP7200				esac
#SCP7200			done
#SCP7200		fi
#SCP7200		if [ -z "${npsu_user_name}" ]; then	#ĥ̵ޤϣեʤ
#SCP7200			npsu_user_name="${user_name}"
#SCP7200		fi
#SCP7200	fi
#COMENT###### 2002.04.04 add for ȥĥ ########

#shift 5
files="${BSPRT20_FILE_STR}"
files_num=${BSPRT20_FILE_VAL}

BSNPS_IF_COPIES=$copies                #20010726 LP.TELL3Ǥ
BSNPS_IF_FILES=$files_num              #20010726 ե
export BSNPS_IF_COPIES BSNPS_IF_FILES  #20010726 Ǥʤ

nobanner="no"
#SCP7500	nobanner="yes"				#SCP7500ˤFMѴfilter¸ߤʤ
nofilebreak="no"
noformfeed="no"

#V11L11	end_filter=`echo "${FILTER}" | sed -e 's/.*\| *//'`
end_filter=`echo "${FILTER}" | sed -e 's/.*| *//'`	#V12L10
stty=

inlist=
for i in ${option_list}
do
	case "${inlist}${i}" in


	nobanner )
#		nobanner="yes"
		nobanner="yes"
		;;

	nofilebreak )
		nofilebreak="yes"
		;;
	noformfeed )
		noformfeed="yes"
		;;


	cpi=pica )
		cpi=10
		;;
	cpi=elite )
		cpi=12
		;;
	cpi=* )
		cpi=`parse ${i}`
		;;

	lpi=* )
		lpi=`parse ${i}`
		;;

	length=* )
		length=`parse ${i}`
		;;

	width=* )
		width=`parse ${i}`
		;;

	stty=* | flist=* | lpd=* )

		inlist=`expr "${inlist}${i}" : "^\([^=]*=\)"`
		case "${i}" in
		${inlist}\'*\' )
			item=`expr "${i}" : "^[^=]*='*\(.*\)'\$"`
			;;
		${inlist}\' )
			continue
			;;
		${inlist}\'* )
			item=`expr "${i}" : "^[^=]*='*\(.*\)\$"`
			;;
		${inlist}* )
			item=`expr "${i}" : "^[^=]*=\(.*\)\$"`
			;;
		*\' )
			item=`expr "${i}" : "^\(.*\)'\$"`
			;;
		* )
			item="${i}"
			;;
		esac

		case "${inlist}" in
		stty= )
			stty="${stty} ${item}"
			;;
		flist= )
			flist="${flist} ${item}"
			;;
		lpd= )
			lpd="${lpd} ${item}"
			;;
		esac

		case "${i}" in
		${inlist}\'*\' )
			inlist=
			;;
		${inlist}\'* )
			;;
		*\' | ${inlist}* )
			inlist=
			;;
		esac
		;;

	* )
		errmsg WARNING ${E_IP_OPTS} \
			"unrecognized \"-o ${i}\" option" \
			"check the option, resubmit if necessary
		printing continues"
		;;
	esac
done

getlpeid() {
	title=${1}
	BIDO='\\~'
	EIDO='~\\'
	BIDN='%~'
	EIDN='~%'

	backward_title=`expr "${title}" : ".*${BIDO}\(.*${EIDO}.*\)"`
	if [ -n "${backward_title}" ]
	then
		ids=`echo "${backward_title}" | sed -n -e "s/${EIDO}.*//p"`
	else
		backward_title=`expr "${title}" : ".*${BIDN}\(.*${EIDN}.*\)"`
		if [ -n "${backward_title}" ]
		then
			ids=`echo "${backward_title}" | sed -n -e "s/${EIDN}.*//p"`
		else
			return
		fi
	fi

	for id in ${ids}
	do
		idinfo=`expr "${id}" : "E:\(.*\)"`
		if [ -n "${idinfo}" ]
		then
			echo "${idinfo}"
			return
		fi
	done
}

lpetitle=`getlpeid "${title}"`
if [ -n "${lpetitle}" ]
then
	REQUESTID_LPE=`expr "${lpetitle}" : "\([^,]*\)"`;	 export REQUESTID_LPE

	if [ "${lpetitle}" != "${REQUESTID_LPE}" ]
	then
		JOBNAME_LPE=`expr "${lpetitle}" : "[^,]*,\([^,]*\),[^,]*,[^,]*$"`
		JOBID_LPE=`expr "${lpetitle}" : "[^,]*,[^,]*,\([^,]*\),[^,]*$"`
		PRTJOB_LPE=`expr "${lpetitle}" : "[^,]*,[^,]*,[^,]*,\([^,]*\)$"`
		export JOBNAME_LPE JOBID_LPE PRTJOB_LPE
	fi
fi


PRINTER_NAME="${printer}";	export PRINTER_NAME	# printer name for print     
USER_NAME="${user_name}";	export USER_NAME	# user name at print request 
JOB_NAME="${request_id}";	export JOB_NAME	# request ID at print request

${BSNPS_OPT_DIR}/bsnpscancelwatch &

# бѥХʡݴؿ  1995.10.18
bsnps_banner () {
	host_name=""
	username=""
	userid=""
	user_id=""
	ID=""
	reqtime=""
	req_time=""
	Files=""
	host_name=`expr "${USER_NAME}" : "\(.*\)\!.*"`
	username=`expr "${USER_NAME}" : ".*\!\(.*\)"`
	if [ "${host_name}" = "`uname -n`" ]
	then
		userid=`id`
		user_id=`expr "${userid}" : "uid=\([0-9]*\)(.*gid=.*"`
	else
		ID=`expr "${JOB_NAME}" : ".*-\([0-9]*\)"`
		FILE="${BSNPS_VAR_PATH}/spool/lp/requests/${host_name}/${ID}-0"
		user_id=`sed -n -e "2p" ${FILE}`
	fi
#	reqtime=`$lpstat_cmd -o ${JOB_NAME}`
#	req_time=`expr "${reqtime}" : ".* .* .* \(.* .* ..:..\).*"`
	flist=`echo "${flist}" | sed -e 's/\\\\ //g'`
	for i in ${flist}
	do
		case "${i}" in
		:* | standardinput:* )
			Files="${Files} StandardInput";;
		* )
			j=`expr "${i}" : "\(.*\):[0-9]*"`
			Files="${Files} ${j}";;
		esac
	done
	Files=`expr "${Files}" : " \(.*\)"`
}

cancel_banner () {
	echo -e "${PAD}${PAD}\c"
	if [ -n "${REQUESTID_LPE}" ]
	then
		echo -e "#####${WIDE_CS} Job ${REQUESTID_LPE}${NORM_CS}${NL}\c"
	else
		echo -e "#####${WIDE_CS} Job ${request_id}${NORM_CS}${NL}\c"
	fi
	echo -e "${PAD}\c"
	echo -e "#####${WIDE_CS} suspended or canceled${NORM_CS}${NL}\c"
	echo -e "${PAD}${PAD}\c"
}

cancel_bannerps () {
	echo "${PAD}${PAD}\c"
	if [ -n "${REQUESTID_LPE}" ]
	then
		echo "##### Job ${REQUESTID_LPE}${NL}\c"
	else
		echo "##### Job ${request_id}${NL}\c"
	fi
	echo "${PAD}\c"
	echo "##### suspended or canceled${NL}\c"
	echo "${PAD}${PAD}\c"
}

cancel_banner_jef () {
    echo -e "${PAD}${PAD}\c"
    if [ -n "${REQUESTID_LPE}" ]
    then
        echo -e "##### Job ${REQUESTID_LPE}${NL}\c"
    else
        echo -e "##### Job ${request_id}${NL}\c"
    fi
    echo -e "${PAD}\c"
    echo -e "##### suspended or canceled${NL}\c"
    echo -e "${PAD}${PAD}\c"
}

canceled () {
	trap '' 13
	if [ "${LPJEF}" = "${BSNPS_OPT_DIR}/bsnpscatvspf66xx" ]
	then
	    cancel_banner_jef
	else
	    if [ "${PSBANNER}" = "${BSNPS_OPT_DIR}/bsnpscatvspps" ]
	    then
		    cancel_bannerps
	    else
		    ${TPUT} s0ds 2>/dev/null
		    ${TPUT} s0ds 2>/dev/null
		    ${TPUT} scs 0 2>/dev/null
		    echo -e "${CR}\c"
		    if [ "${width:-${cols}}" -lt "${MAX_COLS_SMALL_BANNER}" ]
		    then
			    WIDE_CS= NORM_CS=
		    fi
		    cancel_banner
	    fi	

 	    if [ -n "${FF}" -a \( "${FMLPCAT}" = "0" -o "${TERM}" = "ESCP" \) ]
	    then
		    echo -e "${CR}${FF}\c"
	    fi
	fi
}

tput lines 1>/dev/null 2>&1 || TPUT=:

: ${CHARSET:=cs0}

if [ -z "${FILTER}" ]
then
	FILTER="${LPCAT}"
fi

CR=`${TPUT} cr`
[ -z "${CR}" ] && CR="\r"

FF=`${TPUT} ff`

NL="${CR}\n"

lines=`${TPUT} lines`
[ -z "${lines}" -o 0 -ge "${lines}" ] && lines=66

cols=`${TPUT} cols`
[ -z "${cols}" -o 0 -ge "${cols}" ] && cols=132

WIDE_CS=`${TPUT} swidm 2>/dev/null` && NORM_CS=`${TPUT} rwidm 2>/dev/null`
PAD="#####${NL}"

bsnpssetipcmd="" 
BSNPS_F66XX_SIA=""
case "${BSNPS_FILTER_TYPE}" in
	1 )  bsnpssetipcmd=${BSNPS_OPT_DIR}/bsnpssetipf66xx;;
esac
if [ -n "${bsnpssetipcmd}" ]    #PR_REQFROMTNAMEӤꤹ)
then
	for file in ${files}
	do
		PR_REQFROMTNAME=`0<${file} ${bsnpssetipcmd}`
		if [ $? -eq 1 ]; then
			BSNPS_F66XX_SIA="Y"; export BSNPS_F66XX_SIA
		fi
		if [ -n "$PR_REQFROMTNAME" ]
		then
			export PR_REQFROMTNAME	#IPaddress¸ߤˤΤexport롣
		fi
		break
	done
fi
case "${LPCAT} " in
	"${BSNPS_OPT_DIR}/bsnpscatvspfmfnp "* )
	BSNPS_SET_PJI_IF=${TMPPREFIX}${request_id}.pji
	PJI_FILTER="${FILTER}"
	COMMAND=`echo "${PJI_FILTER} > ${BSNPS_SET_PJI_IF}" | sed 's/bsnpscatvspfmfnp/bsnpssetfnppji/' | sed 's/\/lvcnvpdl\([ \|]\)/\/lvcnvpdl -h\1/'`
	for FILE in ${files}
	do
		0<${FILE} eval "${COMMAND}" 
		if [ $? != 0 ]; then
			exit_code=${EXEC_EXIT_NALRT} exit ${EXEC_EXIT_NALRT}
		fi
		break
	done
	if [ -r $BSNPS_SET_PJI_IF ]; then
		BSNPS_SET_PJI_IF_MSG=`cat $BSNPS_SET_PJI_IF`
		if [ -n "$BSNPS_SET_PJI_IF_MSG" ]; then
			   BSNPS_OUTEMU=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k EMU=`
			   BSNPS_OUTDCH=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k DCH=`
			   BSNPS_OUTORT=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k ORT=`
			   BSNPS_OUTPSZ=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k PSZ=`
			   BSNPS_OUTFFL=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k FFL=`
			   BSNPS_OUTUSZ=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k USZ=`
			   BSNPS_OUTBIN=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k BIN=`
			PR_REQFROMTNAME=`echo "$BSNPS_SET_PJI_IF_MSG" | $BSNPS_OPT_DIR/anly_setfnppji_out -k MSG=`
		else
			   BSNPS_OUTEMU=""
			   BSNPS_OUTDCH=""
			   BSNPS_OUTORT=""
			   BSNPS_OUTPSZ=""
			   BSNPS_OUTFFL=""
			   BSNPS_OUTUSZ=""
			   BSNPS_OUTBIN=""
			PR_REQFROMTNAME=""
		fi
		export BSNPS_OUTEMU BSNPS_OUTDCH BSNPS_OUTORT BSNPS_OUTPSZ BSNPS_OUTFFL BSNPS_OUTUSZ BSNPS_OUTBIN
	fi
	rm -fr $BSNPS_SET_PJI_IF
	if [ -n "$PR_REQFROMTNAME" ]
	then
		export PR_REQFROMTNAME	#IPaddress¸ߤˤΤexport롣
	fi
	if [ "$BSNPS_OUTEMU" != "FNP" ]; then
		BSNPS_BANNER_TYPE=2		#ƣͥХʡ
        else
                BSNPS_CANWATCH_TYPE=5   #2002.09.12 add bsnpscancelwatchѹ
	fi
	;;
esac

banner_filter="${LPCAT}"

BSNPS_PRINTERTYPE=$BSNPS_TERM
#2003.11.04 add LX V11L10б
case "${BSNPS_FILTER_TYPE}" in
	1 )  banner_filter="${LPCAT}" ;;
	3 )  case "${BSNPS_PRINTERTYPE}" in
			* ) banner_filter="${LPCAT}"
			;;
	esac ;;
	4 )  banner_filter="${BSNPS_OPT_DIR}/bppcpsbanner | ${end_filter}" ;;
esac

if [ -n "${banner_filter}" ]
then
	banner_filter="| ${banner_filter}"
fi

#COMENT CANCELƻ륳ޥɵưʥХå饦ɡ
#COMENT 1999.10.19 chg SIGKILLоե륿Ƚ̲ǽ2ʥѥ᥿ѹ
#${BSNPS_OPT_DIR}/bsnpscancelwatch ${BSNPS_CANWATCH_TYPE} ${printer} ${user_name} ${request_id} ${TMPPREFIX} &
touch ${CANCEL_FILE_1}
touch ${CANCEL_FILE_2}
#CANCELWATCH_PID=$!	# CANCELƻ륳ޥɤΥץID
#COMENT-------------------------------------------------------------
#COMENTޤǤֲ󥻥ХʡλƤʤ
#COMENTʤޤ֤cancel礢ꡣ
#COMENT-------------------------------------------------------------
#trap 'bsnpsendexec; kill -16 ${CANCELWATCH_PID}; exit ${exit_code}' 0
#COMENTtrap 'rm -fr ${TMPPREFIX}*; rm ${BSNPS_SCDUL_FILE}; kill -16 ${CANCELWATCH_PID}; exit ${exit_code}' 0
#COMENTlpstat̤ȥ顼ɽƱ뤿ᡢlp.tellƤӽФ###
#COMENT# ưȥ饤Υ顼 2001.4.20 ##
if [ -f ${PRWEB_VAR_PATH}error/${printer}.err -o -f ${PRWEB_VAR_PATH}prtMsgTelMsgBox_${request_id} ];then
	${LPTELL} ${printer} quiet
fi
#COMENT# ưȥ饤Υ顼 2001.4.20 ##

if [ ${BSPRTCTLRETRY} -eq 0 ];then # add cluster <--
    FILE_PATH_FAILOVER_PAGE="/var/opt/FJSVlp/page/${JOB_NAME}.failover.page"
    if [ -f "${FILE_PATH_FAILOVER_PAGE}" ];then

        FILE_PATH_CLS_CONF="/shared_lxework/conf/lxecls.conf"
        if [ -f "${FILE_PATH_CLS_CONF}" ];then
            FILE_PATH_PAGE="/var/opt/FJSVlp/page/${USER_NAME}.${JOB_NAME}.page"
            FILE_PATH_PAGE_LOG="/shared_lxework/log/page/${PRINTER_NAME}.page.log"
            CMD_PATH_GET_NFPAGE="${BSNPS_OPT_DIR}/get_nfpage"

            CLSCONF_PRINT=`awk '/^PRINT:/{print $1}' ${FILE_PATH_CLS_CONF} 2>/dev/null`
            if [ "${CLSCONF_PRINT#*:}" != "next" ];then
                CLSCONF_PRINT="top "
            else
                CLSCONF_PRINT="next"
            fi
            START_PAGE_INFO=`${CMD_PATH_GET_NFPAGE} ${FILE_PATH_PAGE} 2>&1`
            RTN_GET_NFPAGE=$?
            if [ ${RTN_GET_NFPAGE} -eq 0 ];then
                START_PAGE=`echo "${START_PAGE_INFO}" |cut -d ":" -f 3`
                STOP_PAGE_INFO=`echo "Stop Page=${START_PAGE_INFO}" |sed "s/\(.*:\).*/\1$[START_PAGE-1]/"`
            else
                (LP_IF_COPIES="standard.sh: get_nfpage error (rtn=${RTN_GET_NFPAGE},[${START_PAGE_INFO}])"; export LP_IF_COPIES; ${BSNPS_OPT_DIR}/writeLogForSH -m 0 -k 0 -P $$)
                START_PAGE_INFO="1:1:1"
                STOP_PAGE_INFO=""
            fi
            STR_DATA=`date '+%Y/%m/%d %H:%M:%S' 2>/dev/null`
            if [ $? -ne 0 ];then
                STR_DATA="----/--/-- --:--:--"
            fi
            STR_HOSTNAME=`hostname 2>/dev/null`
            if [ $? -ne 0 ];then
                STR_HOSTNAME="-"
            fi
            echo "${STR_DATA} ${STR_HOSTNAME} PRINT[${CLSCONF_PRINT}] ${JOB_NAME} ${STOP_PAGE_INFO}" >${FILE_PATH_PAGE_LOG}
            rm -f ${FILE_PATH_FAILOVER_PAGE}

            if [ "${CLSCONF_PRINT}" = "next" ];then
                if [ "${START_PAGE_INFO}" != "1:1:1" ];then
                    BSPRTCTLRETRY=1
                    BSNPS_NFPG_N=`echo "${START_PAGE_INFO}" |cut -d ":" -f 1`
                    BSNPS_NFPG_F=`echo "${START_PAGE_INFO}" |cut -d ":" -f 2`
                    BSNPS_NFPG_P=${START_PAGE}
                fi
            else
                rm -f ${FILE_PATH_PAGE} 2>/dev/null
            fi
        fi # -f "${FILE_PATH_CLS_CONF}"
    fi # -f "${FILE_PATH_FAILOVER_PAGE}"
fi # add cluster -->

LP_IF_DTYPE=1
#2003.11.04 add LX V11L10б
case "${FMLPCAT}" in
	1 ) for file in ${files}; do
	        if [ ! -r "${file}" ]; then
	            (LP_IF_COPIES="standard.sh: "${file}" does not exist."; export LP_IF_COPIES; ${BSNPS_OPT_DIR}/writeLogForSH -m 0 -k 0 -P $$)
	            exit_code=0 exit 0
	        fi
	        break
	    done
	    cat ${PREINIT} | ${LPCAT} ;;
	2 ) cat ${PREINIT} | ${end_filter} ;;
	3 )  ;;
	* ) cat ${PREINIT} | ${LPCAT} ;;
esac
#COMENT#### ץ顼硢exit #####
if [ $? != 0 ]; then
	if [ ${FMLPCAT} != 3 ]
	then
	        exit_code=${EXEC_EXIT_NALRT} exit ${EXEC_EXIT_NALRT}
	fi
	LP_IF_DTYPE=""
fi

if [ ${BSNPS_BANNER_TYPE} = 3 ]; then
    fmeuctofmopt=""
    can_banner=""
    if [ -x ${BSNPS_OPT_DIR}/banneropts ]; then
        fmeuctofmopt=`${BSNPS_OPT_DIR}/banneropts 0 ${end_filter}`
    fi
    if [ -x ${PRCNV_OPT_PATH}/filter/fmbanner ]; then
        can_banner="| ${PRCNV_OPT_PATH}/filter/fmbanner ${fmeuctofmopt}"
    fi
fi

if [ ${FMLPCAT} = 1 ];then
#COMENT CANCELｪλCANCELƻץSIGUSR1
#2003.11.04 add LX V11L10б
	trap 'LP_IF_DTYPE=4; eval canceled ${banner_filter}; bsnpsendexec; exit_code=0 exit' 15
else
	if [ ${BSNPS_BANNER_TYPE} = 3 ]; then
	    trap 'LP_IF_DTYPE=4; eval canceled ${can_banner} ${banner_filter}; bsnpsendexec; exit_code=0 exit' 15
	else
	    trap 'LP_IF_DTYPE=4; eval canceled ${banner_filter}; bsnpsendexec; exit_code=0 exit' 15
	fi
fi

if [ $? != 0 ]; then
	exit_code=${EXEC_EXIT_NALRT} exit ${EXEC_EXIT_NALRT}
fi
LP_IF_DTYPE=""

DATE_CMN=`LC_ALL=C LANG=C date '+%a %H:%M %h %d, %Y %m %d %H %M %S'`
DATE_EX=`LC_ALL=C LANG=C date '+DATE %Y-%m-%d     TIME %H:%M:%S'`	# V5.1

DATE=`echo "$DATE_CMN" | cut -d " " -f 1-5`
DATE_CHARGE=`echo "$DATE_CMN" | cut -d " " -f 5-10`

export DATE DATE_EX DATE_CHARGE                                     # V5.1  DATE_EX ɲ

regular_banner () {
	echo "${CR}\c"
	echo "${PAD}${PAD}${PAD}${PAD}${PAD}\c"
	echo "#####${WIDE_CS}         User: ${user_name}${NORM_CS}${NL}\c"
	if [ -n "$ALIAS_USERNAME" ]
	then
		echo "${PAD}\c"
		echo "#####${WIDE_CS}        Alias: ${ALIAS_USERNAME}${NORM_CS}${NL}\c"
	fi
	if [ -n "${title}" ]
	then
		echo "${PAD}\c"
		title=`echo "${title}" |sed -e '2,$d'`
		if [ ${FMLPCAT} != 0 -a -n "${title}" ]
		then
			case "${TERM}" in
			PSnet | ESCP | ESCPAGE | LIPS | PCL )
				echo "#####${WIDE_CS}        Title: ${title} ${NORM_CS}${NL}\c"
				;;
			*)
				echo "#####${WIDE_CS}        Title: ${title} ${NORM_CS}${NL}\c"
				;;
				esac
		else
			echo "#####${WIDE_CS}        Title: ${title} ${NORM_CS}${NL}\c"
		fi
	fi
	echo "${PAD}\c"
	echo "#####${WIDE_CS}      Printed: ${DATE}${NORM_CS}${NL}\c"
	echo "${PAD}\c"
	if [ -n "${REQUESTID_LPE}" ]
	then
		echo "#####${WIDE_CS}   Job number: ${REQUESTID_LPE}${NORM_CS}${NL}\c"
	else
		echo "#####${WIDE_CS}   Job number: ${request_id}${NORM_CS}${NL}\c"
	fi
	if [ "${REQUESTID_LPE}" != "${lpetitle}" ]
	then
		echo "${PAD}\c"
		echo "#####${WIDE_CS}     Job name: ${JOBNAME_LPE}${NORM_CS}${NL}\c"
		echo "${PAD}\c"
		echo "#####${WIDE_CS}       Job ID: ${JOBID_LPE}${NORM_CS}${NL}\c"
		echo "${PAD}\c"
		echo "#####${WIDE_CS} Print Job ID: ${PRTJOB_LPE}${NORM_CS}${NL}\c"
	fi
	echo "${PAD}${PAD}${PAD}${PAD}${PAD}\c"
 	if [ -n "${FF}" -a \( "${FMLPCAT}" = "0" -o "${TERM}" = "ESCP" \) ]
	then
		echo "${CR}${FF}\c"
	fi
}

regular_bannerps () {
	echo "${PAD}${PAD}${PAD}${PAD}${PAD}\c"
	echo "#####         User: ${user_name}${NL}\c"
	if [ -n "$ALIAS_USERNAME" ]
	then
		echo "${PAD}\c"
		echo "#####        Alias: ${ALIAS_USERNAME}${NL}\c"
	fi
	if [ -n "${title}" ]
	then
		echo "${PAD}\c"
		title=`echo "${title}" |sed -e '2,$d'`
		echo "#####        Title: ${title}${NL}\c"
	fi
	echo "${PAD}\c"
	echo "#####      Printed: ${DATE}${NL}\c"
	echo "${PAD}\c"
	if [ -n "${REQUESTID_LPE}" ]
	then
		echo "#####   Job number: ${REQUESTID_LPE}${NL}\c"
	else
		echo "#####   Job number: ${request_id}${NL}\c"
	fi
	if [ "${REQUESTID_LPE}" != "${lpetitle}" ]
	then
		echo "${PAD}\c"
		echo "#####     Job name: ${JOBNAME_LPE}${NL}\c"
		echo "${PAD}\c"
		echo "#####       Job ID: ${JOBID_LPE}${NL}\c"
		echo "${PAD}\c"
		echo "##### Print Job ID: ${PRTJOB_LPE}${NL}\c"
	fi
	echo "${PAD}${PAD}${PAD}${PAD}${PAD}\c"
 	if [ -n "${FF}" -a \( "${FMLPCAT}" = "0" -o "${TERM}" = "ESCP" \) ]
	then
		echo "${CR}${FF}\c"
	fi
}

regular_bannerjef () {
#2003.11.04 add LX V11L10б
	echo -e "${CR}\c"
	echo -e "${PAD}${PAD}${PAD}${PAD}${PAD}\c"
	if [ "${BSNPS_FOR_NPS}" = "NPSU" ]; then
		echo -e "#####         User: ${npsu_user_name}${NL}\c"
	else
		echo -e "#####         User: ${user_name}${NL}\c"
	fi
	if [ -n "$ALIAS_USERNAME" ]
	then
		echo -e "${PAD}\c"
		echo -e "#####        Alias: ${ALIAS_USERNAME}${NL}\c"
	fi
	if [ -n "${title}" ]
	then
		echo -e "${PAD}\c"
		title=`echo "${title}" |sed -e '2,$d'`
		echo -e "#####        Title: ${title}${NL}\c"
	fi
	echo -e "${PAD}\c"
	echo -e "#####      Printed: ${DATE}${NL}\c"
	echo -e "${PAD}\c"
	if [ -n "${REQUESTID_LPE}" ]
	then
		echo -e "#####   Job number: ${REQUESTID_LPE}${NL}\c"
	else
		echo -e "#####   Job number: ${request_id}${NL}\c"
	fi
	if [ "${REQUESTID_LPE}" != "${lpetitle}" ]
	then
		echo -e "${PAD}\c"
		echo -e "#####     Job name: ${JOBNAME_LPE}${NL}\c"
		echo -e "${PAD}\c"
		echo -e "#####       Job ID: ${JOBID_LPE}${NL}\c"
		echo -e "${PAD}\c"
		echo -e "##### Print Job ID: ${PRTJOB_LPE}${NL}\c"
	fi
	echo -e "${PAD}${PAD}${PAD}${PAD}${PAD}\c"
 	if [ -n "${FF}" -a \( "${FMLPCAT}" = "0" -o "${TERM}" = "ESCP" \) ]
	then
		echo -e "${CR}${FF}\c"
	fi
}

small_banner () {
	echo "${CR}\c"
	echo "${PAD}\c"
	echo "#####         User: ${user_name}${NL}\c"
	if [ -n "${title}" ]
	then
		title=`echo "${title}" |sed -e '2,$d'`
		echo "#####        Title: ${title}${NL}\c"
	fi
	echo "#####         Date: ${DATE}${NL}\c"
	if [ -n "${REQUESTID_LPE}" ]
	then
		echo "#####          Job: ${REQUESTID_LPE}${NL}\c"
	else
		echo "#####          Job: ${request_id}${NL}\c"
	fi
	if [ "${REQUESTID_LPE}" != "${lpetitle}" ]
	then
		echo "#####     Job name: ${JOBNAME_LPE}${NORM_CS}${NL}\c"
		echo "#####       Job ID: ${JOBID_LPE}${NORM_CS}${NL}\c"
		echo "##### Print Job ID: ${PRTJOB_LPE}${NORM_CS}${NL}\c"
	fi
	echo "${PAD}\c"
 	if [ -n "${FF}" -a \( "${FMLPCAT}" = "0" -o "${TERM}" = "ESCP" \) ]
	then
		echo "${CR}${FF}\c"
	fi
}

idremove() {
	forward_title=`expr "${title}" : "\(.*\)${1}.*${2}"`
	backward_title=`expr "${title}" : ".*${1}\(.*${2}.*\)"`
	id=`echo "${backward_title}" | sed -n -e "s/${2}.*//p"`
	backward_title=`expr "${backward_title}" : "${id}${2}\(.*\)"`

	if [ 0 != `expr "${title}" : ".*${1}.*${2}.*"` ]
	then
		echo "${forward_title}${backward_title}"
	else
		echo "${title}"
	fi
}

if [ "no" = "${nobanner}" ]
then
	if [ "${width:-${cols}}" -lt "${MAX_COLS_SMALL_BANNER}" ]
	then
		banner=small_banner
	else
	
		if [ "${LPJEF}" = "${BSNPS_OPT_DIR}/bsnpscatvspf66xx" ]
		then
			banner=regular_bannerjef
		else
			fmformat_filter=""

			banner="regular_banner | ${fmformat_filter} ${PRCNV_OPT_PATH}/filter/fmeuctofm"
			if [ "${BSNPS_FOR_NPS}" = "NPSU" -o ${BSNPS_BANNER_TYPE} = 3 ]; then	#NPSU or FNP?  2002.2.8 add
				if [ -r ${BSNPS_ETC_PATH}/bsnps/bana/prebana ]; then
					BSNPS_EXT_FILTER="cat ${BSNPS_ETC_PATH}/bsnps/bana/prebana"
				fi
				if [ -r ${BSNPS_ETC_PATH}/bsnps/bana/prebana.${PRINTER_NAME} ]; then
					BSNPS_EXT_FILTER="cat ${BSNPS_ETC_PATH}/bsnps/bana/prebana.${PRINTER_NAME}"
				fi
				if [ "${BSNPS_EXT_FILTER}" ]; then
					fmeuctofmopt=""
					if [ -x ${BSNPS_OPT_DIR}/banneropts ]; then
						fmeuctofmopt=`${BSNPS_OPT_DIR}/banneropts 0 ${end_filter}`
					fi
					if [ -x ${PRCNV_OPT_PATH}/filter/fmbanner ]; then
						banner="${BSNPS_EXT_FILTER} | ${PRCNV_OPT_PATH}/filter/fmbanner ${fmeuctofmopt}"
					fi
				fi
			fi																		#NPSU or FNP?  2002.2.8 add
		fi
	fi

	if [ "${PSBANNER}" = "${BSNPS_OPT_DIR}/bsnpscatvspps" ]
	then
		banner=regular_bannerps
	fi
		
	title=`echo "${title}" | sed -e '2,$d'`
	remIDtitle=`idremove '\\\\~' '~\\\\'`
	if [ "${title}" = "${remIDtitle}" ]
	then
		title=`idremove '%~' '~%'`
	else
		title="${remIDtitle}"
	fi
#SCP7200		if [ "${BSNPS_FOR_NPS}" = "NPSU" ]; then	#NPSU?
#SCP7200			if [ "${TERM}" = "VSPNLP" -a ${BSNPS_BANNER_TYPE} = 2 ]; then	#FM NLP?
#SCP7200				title=`echo "${title}" | ${BSNPS_OPT_DIR}/bsnps_cut -c1-91`			#92ketadesizenkaigyou
#SCP7200				BSNPS_TITLE=`expr "${BSNPS_TITLE}" : ".*%~\(.*\)~%.*"`	#
#SCP7200				BSNPS_TITLE=`echo "${title}%~${BSNPS_TITLE}~%"`
#SCP7200				export BSNPS_TITLE
#SCP7200			fi
#SCP7200		fi

		LP_IF_DTYPE=2
		if [ ${EXLOOP} -eq 1 ]
		then
			while :
			do
				eval "${banner} ${banner_filter}"
				case $? in
				0 )
					break ;;
				230|231|232 )
					;;
				* )
					exit_code=${EXEC_EXIT_NALRT} exit ${EXEC_EXIT_NALRT} ;;
				esac
			done
		else
			eval "${banner} ${banner_filter}"
			if [ $? != 0 ]; then
				exit_code=${EXEC_EXIT_NALRT} exit ${EXEC_EXIT_NALRT}
			fi
		fi
		LP_IF_DTYPE=""
fi





check_formfeed () {
	if [ -n "${FF}" -a "no" = "${nofilebreak}" -a "${FMLPCAT}" = "0" ]
	then
		if [ "no" = "${noformfeed}" ]
		then
			echo "${CR}${FF}\c" | ${LPCAT}
		fi
	fi
}
badfileyet=
LP_IF_DTYPE=3

#COMENT# ɤФǽ 2001.5.21 ##
BSNPS_START_COPIES=1
#SCP7200	if [ "${BSNPS_FOR_NPS}" = "NPSU" ]; then	#NPSU?
#SCP7200		if [ ${BSNPS_FILTER_TYPE} = 3 -o ${BSNPS_FILTER_TYPE} = 1 ]; then	#FM/FNP? add JEF(2001.11.08)
#SCP7200			if [ -x ${BSNPS_OPT_DIR}/getoptvalue ]; then	#getoptvalue?
#SCP7200				BSNPS_START_COPIES=`/opt/FJSVbsnps/usr/lib/bsnps/getoptvalue a ${end_filter} | cut -f1 -d: | grep "^[0-9][0-9]*$"`
#SCP7200				if [ "${BSNPS_START_COPIES}" ]; then			#Is option normal?
#SCP7200					if [ ${BSNPS_START_COPIES} -gt $copies ]; then
#SCP7200						BSNPS_START_COPIES=$copies              #ͤ礭ʤ
#SCP7200					fi
#SCP7200				else
#SCP7200					BSNPS_START_COPIES=1                            #ͤʤʤ飱
#SCP7200				fi
#SCP7200			fi
#SCP7200		fi
#SCP7200	fi
#COMENT# ɤФǽ 2001.5.21 ##

i=1
while [ $i -le $copies ]
do
	j=1
	LP_IF_COPIES="$i/${copies}"
	for file in ${files}
	do
		LP_IF_FILES="$j/${files_num}"
		while :
		do

			if [ -r "${file}" ]
			then

				#BSPRTCTL2.0 add-start
				SVFILTER="${FILTER}"
				if [ ${BSPRTCTLRETRY} -eq 1 ]
				then
					if [ \( ${i} -le ${BSNPS_NFPG_N} \) -o \( ${i} -eq ${BSNPS_NFPG_N} -a ${j} -le ${BSNPS_NFPG_F} \) ]
					then
						nfpageoption="${BSNPS_NFPG_N}:${BSNPS_NFPG_F}:${BSNPS_NFPG_P}"
						FILTER="${ORIGINAL_FILTER} -a${nfpageoption} ${BSPRT20_REQ___ID}"
						(LP_IF_COPIES=${nfpageoption};	 export LP_IF_COPIES; ${BSNPS_OPT_DIR}/writeLogForSH -m 0 -k 0 -P $$)
					fi
				fi
				#BSPRTCTL2.0 add-end

				#LXE V11L10 lp.tell2SǻȤ뤿export
				EXIT_CODE=${TMPPREFIX}e ;export EXIT_CODE
				trap '' 1	# Let the filter handle a hangup
				trap '' 2 3	# and interrupts
				trap 13
				(
					0<${file} eval ${FILTER} 2>&1 1>&3
					echo $? >${EXIT_CODE}
				) | ${LPTELL} ${printer}
				END_CODE=$?
				trap '' 13
				trap 'catch_hangup; exit_code=129 exit 129' 1
				trap 'catch_interrupt; exit_code=129 exit 129' 2 3
				exit_code=`cat ${EXIT_CODE}`
				FILTER="${SVFILTER}"    #BSPRTCTL2.0 add
                if [ ${END_CODE} -eq 60 -o ${END_CODE} -eq 70 ]; then
                    if [ \( ${exit_code} -eq 0 -a \( $j -lt ${files_num} -o $i -lt ${copies} \) \) -o ${exit_code} -eq 230 ]; then
                        ${BSNPS_OPT_DIR}/release -p ${printer} -i ${JOB_ID}
                        if [ $? -eq 0 ]; then
                            trap 'bsnpsendexec; exit_code=0 exit' 15
                        fi
                    else
                        if [ ${END_CODE} -eq 70 ]; then
                            trap 'bsnpsendexec; exit_code=0 exit' 15
                        fi
                    fi
                fi
                if [ ${END_CODE} -eq 60 ]; then
                    exit_code=0
                    exit
                fi
                if [ ${END_CODE} -eq 70 ]; then
                    while [ 1 ]
                    do
                        sleep 1
                    done
                fi

				#####
				#   0 : copies & files	normalcount
				# 230 : copies & files	nocount
				# 231 : copies nocount   files goto1
				# 232 : copies & files	goto1
				#####
				if [ ${EXLOOP} -eq 1 ]
				then
					case $exit_code in
					0 )
						check_formfeed
						break
						;;
					230 )
						check_formfeed ;;
					231 )
						check_formfeed
						break 2;;
					232 )
						check_formfeed
						break 2;;
					* )
						trap '' 15  # Avoid dying from disable
#LINUX						sleep 4	    # Give $LPTELL a chance to tell
						exit_code=${EXEC_EXIT_NALRT} exit ${EXEC_EXIT_NALRT}
					esac
				else
					if [ \( -n "${exit_code}" -a 0 -ne "${exit_code}" \) -o \( "60" = "${END_CODE}" \) ]
					then
						trap '' 15  # Avoid dying from disable
#LINUX						sleep 4	    # Give $LPTELL a chance to tell
						exit_code=${EXEC_EXIT_NALRT} exit ${EXEC_EXIT_NALRT}
					fi
					check_formfeed
					break
				fi

			else

				if [ "${i}" -le 1 -o -z "${badfileyet}" ]
				then
					errmsg WARNING ${E_IP_BADFILE} \
						"cannot read file \"${file}\"" \
						"see if the file still exists and is readable,
			or consult your system administrator;
			printing continues"
					badfileyet=yes
				fi
				break

			fi
			done
			j=`expr $j + 1`
	done

	if [ ${EXLOOP} -eq 1 ]
	then
		case $exit_code in
		231 )
			;;
		232 )
			i=1 ;;
		* )
#COMENT# ɤФǽ 2001.5.21 ##
#SCP7200		if [ $i -lt $BSNPS_START_COPIES ]; then	#=1ڤ=copiesξ硢filterƤӽФ
#SCP7200			i=`expr ${BSNPS_START_COPIES} - 1`
#SCP7200		fi
#COMENT# ɤФǽ 2001.5.21 ##
			i=`expr $i + 1` ;;
		esac
	else
			i=`expr $i + 1`
	fi

done
LP_IF_DTYPE=""


if [ -n "${exit_code}" -a 0 -ne "${exit_code}" ]
then
	exit ${exit_code}
fi

exit_code=0 exit 0
